# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#' Convert a matrix to a vector of arrays
#'
#' @param x object to be converted
#'
#' @details The algorithms in kdtools can accept either matrices or an
#' \link{arrayvec} object. When a matrix is passed, it is converted to
#' an arrayvec object internally and the results are converted back to
#' a matrix. For optimal performance, pre-convert matrices.
#'
#' @examples
#' x = matrix(1:10, 5)
#' y = matrix_to_tuples(x)
#' str(x)
#' str(y)
#' y[1:2, ]
#'
#' @rdname convert
#' @export
matrix_to_tuples <- function(x) {
    .Call(`_kdtools_matrix_to_tuples`, x)
}

#' @rdname convert
#' @export
tuples_to_matrix <- function(x) {
    .Call(`_kdtools_tuples_to_matrix`, x)
}

tuples_to_matrix_rows <- function(x, a, b) {
    .Call(`_kdtools_tuples_to_matrix_rows`, x, a, b)
}

kd_order_df_no_validation <- function(df, idx, parallel = TRUE) {
    .Call(`_kdtools_kd_order_df_no_validation`, df, idx, parallel)
}

kd_order_df <- function(df, idx, parallel = TRUE) {
    .Call(`_kdtools_kd_order_df`, df, idx, parallel)
}

kd_rq_df_no_validation <- function(df, idx, lower, upper) {
    .Call(`_kdtools_kd_rq_df_no_validation`, df, idx, lower, upper)
}

kd_rq_df <- function(df, idx, lower, upper) {
    .Call(`_kdtools_kd_rq_df`, df, idx, lower, upper)
}

kd_nn_df_no_validation <- function(df, idx, w, key, n) {
    .Call(`_kdtools_kd_nn_df_no_validation`, df, idx, w, key, n)
}

kd_nn_df <- function(df, idx, w, key, n) {
    .Call(`_kdtools_kd_nn_df`, df, idx, w, key, n)
}

kd_sort_ <- function(x, inplace, parallel) {
    .Call(`_kdtools_kd_sort_`, x, inplace, parallel)
}

kd_is_sorted_ <- function(x, parallel) {
    .Call(`_kdtools_kd_is_sorted_`, x, parallel)
}

lex_sort_ <- function(x, inplace) {
    .Call(`_kdtools_lex_sort_`, x, inplace)
}

kd_lower_bound_ <- function(x, value) {
    .Call(`_kdtools_kd_lower_bound_`, x, value)
}

kd_upper_bound_ <- function(x, value) {
    .Call(`_kdtools_kd_upper_bound_`, x, value)
}

kd_range_query_ <- function(x, lower, upper) {
    .Call(`_kdtools_kd_range_query_`, x, lower, upper)
}

kd_rq_indices_ <- function(x, lower, upper) {
    .Call(`_kdtools_kd_rq_indices_`, x, lower, upper)
}

kd_rq_circular_ <- function(x, center, radius) {
    .Call(`_kdtools_kd_rq_circular_`, x, center, radius)
}

kd_rqi_circular_ <- function(x, center, radius) {
    .Call(`_kdtools_kd_rqi_circular_`, x, center, radius)
}

kd_nearest_neighbor_ <- function(x, value) {
    .Call(`_kdtools_kd_nearest_neighbor_`, x, value)
}

kd_binary_search_ <- function(x, value) {
    .Call(`_kdtools_kd_binary_search_`, x, value)
}

kd_nearest_neighbors_ <- function(x, value, n) {
    .Call(`_kdtools_kd_nearest_neighbors_`, x, value, n)
}

kd_nn_indices_ <- function(x, value, n) {
    .Call(`_kdtools_kd_nn_indices_`, x, value, n)
}

kd_order_ <- function(x, inplace, parallel) {
    .Call(`_kdtools_kd_order_`, x, inplace, parallel)
}

using_circular_lexicographical_compare <- function() {
    .Call(`_kdtools_using_circular_lexicographical_compare`)
}

levenshtein <- function(s1, s2) {
    .Call(`_kdtools_levenshtein`, s1, s2)
}

